#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		__strip		/bin/true
#-----------------------------------------------------------------------------
Name		:	glibc
Version		:	2.39
Release		:	17.0.10.rel%{?dist}
Summary		:	The GNU libc libraries
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2+ and LGPLv2+ with exceptions and GPLv2+
URL		:	https://www.gnu.org/software/libc/

Source0		:	%{name}-%{version}.tar.xz
Patch0		:	%{name}-%{version}-fhs-1.patch

#-----------------------------------------------------------------------------
Requires(pre)	:	setup

# The dynamic linker supports DT_GNU_HASH
Provides	:	rtld(GNU_HASH)
#-----------------------------------------------------------------------------
%description
The glibc package contains standard libraries which are used by
multiple programs on the system. In order to save disk space and
memory, as well as to make upgrading easier, common system code is
kept in one place and shared between programs. This particular package
contains the most important sets of shared libraries: the standard C
library and the standard math library. Without these two libraries, a
Linux system will not function.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%{_includedir}/*.h
%{_includedir}/arpa/*.h
%{_includedir}/bits/stab.def
%{_includedir}/bits/*.h
%{_includedir}/bits/platform/x86.h
%{_includedir}/bits/platform/features.h
%{_includedir}/bits/types/*.h
%{_includedir}/finclude/math-vector-fortran.h
%{_includedir}/gnu/*.h
%{_includedir}/net/*.h
%{_includedir}/netash/*.h
%{_includedir}/netatalk/*.h
%{_includedir}/netax25/*.h
%{_includedir}/netinet/*.h
%{_includedir}/neteconet/*.h
%{_includedir}/netpacket/*.h
%{_includedir}/netipx/*.h
%{_includedir}/netiucv/*.h
%{_includedir}/netrom/*.h
%{_includedir}/netrose/*.h
%{_includedir}/nfs/*.h
%{_includedir}/protocols/*.h
%{_includedir}/rpc/*.h
%{_includedir}/scsi/*.h
%{_includedir}/sys/*.h
%{_includedir}/sys/platform/x86.h

%{_sbindir}/ldconfig
%{_sbindir}/sln

%dir %{_libdir}/locale
%dir %{_sysconfdir}/ld.so.conf.d
%{_sysconfdir}/ld.so.cache
%config (noreplace) %{_sysconfdir}/ld.so.conf
%config (noreplace) %{_sysconfdir}/nsswitch.conf
%config (noreplace) %{_sysconfdir}/nscd.conf
%{_sysconfdir}/rpc

%{_libexecdir}/getconf/*

#{_sbindir}/iconvconfig
#{_sbindir}/nscd
#{_sbindir}/zic

%{_bindir}/*

/%{_lib}/ld*.so*
%{_libdir}/ld*.so*
%{_libdir}/*.a
%{_libdir}/*crt*.o
%{_libdir}/lib*.so*
%{_libdir}/audit/*.so
%{_libdir}/gconv/*.so
%{_libdir}/gconv/gconv-modules
%{_libdir}/gconv/gconv-modules.d/gconv-modules-extra.conf
%{_libdir}/locale/locale-archive

%{_datadir}/i18n/locales/*
%{_datadir}/i18n/charmaps/*
%{_datadir}/locale/dir
%{_datadir}/locale/locale.alias
%{_datadir}/locale/libc.info*
%{_datadir}/locale/*/LC_MESSAGES/libc.mo

%{_var}/lib/nss_db/Makefile


#=============================================================================
%prep
%setup -q
#apply Patch
%patch -P 0 -p1

#-----------------------------------------------------------------------------
%build

mkdir build
pushd build

#Ensure that the ldconfig and sln utilities
#are installed into /usr/sbin
echo "#-------------------"	>  configparms
echo "slibdir=/usr/lib"		>> configparms
echo "rtlddir=/usr/lib"		>> configparms
echo "sbindir=/usr/bin"		>> configparms
echo "rootsbindir=/usr/sbin"	>> configparms
echo "#-------------------"	>> configparms

../configure                                            \
        --prefix=%{_prefix}				\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
        --bindir=%{_bindir}				\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--sharedstatedir=%{_var}/lib			\
	--datarootdir=%{_datadir}			\
	--infodir=%{_datadir}/locale			\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--with-headers=%{_includedir}			\
	--enable-bind-now				\
	--enable-cet					\
	--enable-fortify-source				\
	--enable-kernel=4.14				\
        --enable-stack-protector=strong                 \
	--disable-profile				\
	--disable-werror				\
	libc_cv_slibdir=%{_libdir}
        

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} PARALLELMFLAGS="%{_smp_mflags}"
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

case %{_arch} in
  i?86)
    ln -sfv ld-linux.so.2 %{buildroot}/lib/ld-lsb.so.3
    ;;
  x86_64)
    %{__mkdir_p} %{buildroot}/lib64
    ln -sfv ../usr/lib/ld-linux-x86-64.so.2 %{buildroot}/lib64
    ln -sfv ../usr/lib/ld-linux-x86-64.so.2 %{buildroot}/lib64/ld-lsb-x86-64.so.3
    ;;
  esac

%{__make}						\
	-C build					\
	DESTDIR="%{buildroot}"				\
	install

# Shipped in tzdata
%{__rm} -f %{buildroot}%{_bindir}/{tzselect,zdump,zic}

#install all locales listed in glibc
%{__make}						\
	PARALLELMFLAGS="%{_smp_mflags}"			\
	-C build					\
	DESTDIR="%{buildroot}"				\
	localedata/install-locales

#Fix a hardcoded path to the executable loader in the ldd script:
sed -i                                                  \
  -e'/RTLDLIST=/s@/usr@@g'                              \
  %{buildroot}%{_bindir}/ldd

%{__mkdir_p} %{buildroot}/var/cache/nscd

cp nscd/nscd.conf %{buildroot}%{_sysconfdir}
cp nss/nsswitch.conf %{buildroot}%{_sysconfdir}

#Install locale dir
%{__mkdir_p} %{buildroot}%{_libdir}/locale

mkdir -p %{buildroot}%{_sysconfdir}/ld.so.conf.d
cat > %{buildroot}%{_sysconfdir}/ld.so.conf << EOF
#----------------------------------------------------------------------
include ld.so.conf.d/*.conf
#----------------------------------------------------------------------
EOF


#-----------------------------------------------------------------------------
%changelog
